package org.artifactory.opentracing;

import io.opentracing.Span;
import org.slf4j.MDC;

import static org.artifactory.opentracing.ArtifactoryTracer.UBER_TRACE_ID;

/**
 * Represents a server tracing span.
 *
 * @author Uriah Levy
 */
public class ServerTracingSpan {
    private Span span;

    ServerTracingSpan(Span span) {
        this.span = span;
    }

    public Span getSpan() {
        return span;
    }

    public void finish() {
        span.finish();
        MDC.remove(UBER_TRACE_ID);
    }
}
